Skip to main content
`Ctrl`+`K`

# Release notes

A comprehensive list of changes can be found in the Changelog.

## Version 3.28.0

17 March 2026: 3.28.0

Release notes still to be written.

## Version 3.27.0

28 December 2025: 3.27.0

This is an ordinary feature release. Highlights:

- ASE now requires Python 3.10 or newer.

- As part of the overall decentralisation efforts, the \(ase.ga\) module has moved to a standalone project, ase-ga.

- Many Tutorials have been ported to \(sphinx-gallery <https://sphinx-gallery.github.io/>__\) and are now tested automatically, resulting in various fixes.

- Multiple improvements across the `ase.thermochemistry` module.

## Version 3.26.0

12 August 2025: 3.26.0

This is the first release following the 2025 ASE workshop at EPFL. The workshop established plans for ASE 4 as well as a steering committee. New features for ASE 4 will be developed under the ase._4 namespace and are experimental. More information about these developments should be added to the documentation in the near future.

The web page has been moved to ase-lib.org and now uses the sphinx book theme. It is now deployed automatically using Gitlab pages and continuous integration.

Optimizers can now work on any target function with derivatives thanks to the limited `Optimizable` interface. One future goal of this effort is to replace Filters with simpler objects and make it easier to control e.g. tolerances in cell optimizations.

Highlights:

- Breaking change: IO: Removed unused `IOFormat.open()` method (MR: !3738).

- Breaking change: Optimizers: The `Optimizable` interface now works in terms of arbitrary degrees of freedom rather than Cartesian (Nx3) ones. This can break code that uses internals of `Optimizer` such as `converged()`. Please note that the interface is still considered an internal feature and may still change significantly. (MR: !3732)

- Changed `ELK` based on `GenericFileIOCalculator` (MR: !3736)

- Molecular dynamics: Added anisotropic NpT with MTK equations (MR: !3595).

- GUI: Multiple bugfixes related to keyboard shortcuts, particularly for OSX.

- GUI: Added general window to view and edit data on atoms directly in the same style as the cell editor. The window currently edits symbols and Cartesian positions only (MR: !3790).

## Version 3.25.0

11 April 2025: 3.25.0

Starting with this release, release notes will change format. Until now, the release notes were mostly a changelog. Instead, release notes should now consist of prose and/or a shorter list of highlights. In addition, a more detailed Changelog is now generated using scriv.

Noteworthy changes in this release are:

- BREAKING `ase.io.orca.read_orca_output` now returns `Atoms` with attached properties. `ase.io.read()` will use this function. The previous behaviour (return results dictionary only) is still available from function `ase.io.orca.read_orca_outputs()`. (MR: !3599)

- The “heavy-weight” database backends in `ase.db` have been moved to a separate project, ase/ase-db-backends.

- The EAM calculator can now compute stress tensors (MR: !3581).

- Molecular dynamics: Added isotropic NPT with MTK equations (MR: !3550).

## Version 3.24.0

28 December 2024: 3.24.0

### Requirements

- The minimum supported Python version has increased to 3.9 (MR: !3473)

### Breaking changes

- The `master` parameter to each Optimizer is now passed via `**kwargs` and so becomes keyword-only. (MR: !3424)

- Removed legacy `read_cell` and `write_cell` functions from ase.io.castep. (MR: !3435)

- Removed deprecated `force_consistent` option from Optimizer (MR: !3424)

- `ase.spectrum.band_structure.BandStructurePlot`: the `plot_with_colors()` has been removed and its features merged into the `plot()` method.

### Highlights

- Major improvements to `find_optimal_cell_shape()`: improve target metric; ensure rotationally invariant results; avoid negative determinants; improved performance via vectorisation (MR: !3404, MR: !3441, MR: !3474). The `norm` argument to `ase.build.supercells.get_deviation_from_optimal_cell_shape()` is now deprecated.

- Added new `FiniteDifferenceCalculator`, which wraps other calculator for finite-difference forces and strains (MR: !3509)

- Added two new MD thermostats: `ase.md.bussi.Bussi` (MR: !3350) and `ase.md.nose_hoover_chain.NoseHooverChainNVT` (MR: !3508)

- Added atom-projected partial phonon dos to `ase.phonons.Phonons.get_dos()` (MR: !3460)

- New module `ase.pourbaix` written to replace `ase.phasediagram.Pourbaix` (MR: !3280), with improved energy definition and visualisation

## Version 3.23.0

31 May 2024: 3.23.0

- Add `FixSubsetCom` to fix the center of mass of the specified subset of atoms (MR: !3193).

- Add the `indices` option to `ase.Atoms.get_center_of_mass()` to compute the center of mass of the specified subset of atoms (MR: !3193).

- All saddle-point search and minimum-energy path methods have been moved into a new `ase.mep` module. You should start importing from this location; e.g., `from ase.mep import NEB, DyNEB` (MR: !2974).

- Fix `ase.constraints.FixCom.adjust_momenta()` to have no center-of-mass momentum (MR: !2947)

- `ase.build.surface.graphene()` now takes a `thickness` argument (MR: !2963)

- `ase.build.bulk()` now assigns initial magnetic moments to BCC Fe, Co, and Ni.

- `ase.build.make_supercell()` can now control how to order the atoms in the supercell via the option `order` (MR: !2800)

- `mask()` returns the mask of nonzero cell vectors, an array of three booleans.

- `reciprocal()` now guarantees that cell vectors which are zero correspond to reciprocal cell vectors that are also zero. Previously the reciprocal cell vectors could have small nonzero values due to floating point tolerance.

- The `Cell` object now has `normal()` and `normals()` which calculate normal vectors to one or all pairs of cell vectors. Also added `area()` and `areas()`, which return the area spanned by one or all pairs of cell vectors.

- New `a2b` and `periodic` formats for `Formula` objects. See `ase.formula.Formula.format()`. The `abc` format has been renamed to `ab2`.

- IO formats can now be implemented in separate packages and registered in ase with the entry point `ase.ioformats` in the external package configuration. This entry point only accepts objects of the type `ExternalIOFormat`.

- `ase.phonons.Displacement` now has a `comm` keyword argument to better support parallelization.

- Fix `ase.build.rotate.minimize_rotation_and_translation()` for systems with periodic boundary conditions.

- Fix `ase.io.db.row.AtomsRow.charge()`, which was looking for `inital_charges` instead of `initial_charges`.

- Fixed definition of the Lennard-Jones potential in `ase.utils.ff` (MR: !2842)

- The `x3d` viewer has improved aesthetics (MR: !2831)

- Added a function, `ase.dft.kpoints.mindistance2monkhorstpack()`, to construct a Monkhorst-Pack grid (MR: !2811)

- Fixed turbomole calculator parsing issues when `=` are present in data groups (MR: !2808)

- Fixed round-trip dict (de)serialization with `FixedMode` constraint (MR: !2801)

- Show total number of rows in ASE database (MR: !2797)

- Fix units of magnetic moments in ASE database (MR: !2793)

- General improvements to POVRay colors (MR: !2775, MR: !2767)

- Remove deprecated CLI functions, such as the old `ase-gui` command (MR: !2770)

- Fix calculation of stresses in `ase.stress.full_3x3_to_voigt_6_stress()` (MR: !2765)

- Add polarization parser for FHI-AIMS calculator (MR: !2763)

- Fix bug in `ase.atoms.Atoms.get_center_of_mass()` (MR: !2712)

- Fix multiprocessing bug with `ase.neb.NEB` (MR: !2695)

- NEB calculations now call `get_forces()` instead of `get_potential_energy()` followed by `get_forces()` to prevent duplicate work (MR: !2678)

- Improve performance of `ase.build.supercells.make_supercell()` for large supercells (MR: !2639)

- Fix conservation of momentum in `ase.md.langevin.Langevin` (MR: !2632)

- Fix bug in `ase.vibrations.Vibrations` causing property calculations to always use the default method (MR: !3012)

- Replaced `ase.phasediagram.Pourbaix` class (to be deprecated) with the `ase.pourbaix` module. The latter includes a `Pourbaix` class able to plot a complete diagram given a set of references. The decomposition energy is now shown on a colormap and the phase boundaries are determined with a plane intersection method. (MR: !3280)

Calculators:

- Accelerate `EMT` using NumPy more (MR: !3241)

- Remove `ase.calculators.vasp.vasp_auxiliary.xdat2traj`. Use `ase.io` instead (MR: !2948)

- Created new module `ase.calculators.harmonic` with the `ase.calculators.harmonic.HarmonicCalculator` for calculations with a Hessian-based harmonic force field. Can be used to compute Anharmonic Corrections to the Harmonic Approximation.

- Created new `ase.calculators.plumed.Plumed` that is an interface between ASE and Plumed for carrying out enhanced sampling methods and MD postprocessing.

- `ase.calculators.kim.kimmodel.KIMModelCalculator` updated to allow users to change the parameters of OpenKIM portable models at run time (see https://openkim.org/doc/repository/kim-content/ for an explanation of types of OpenKIM models).

- `ase.calculators.mopac.MOPAC` updated to support MOPAC version 22, which was released under GPL in May 2022. When using this MOPAC version or newer, the output “final heat of formation” will be interpreted as potential/free energy for ASE purposes.

- Fix ordering of kpoint and spin indices in `ase.calulators.abc.GetOutputsMixin.get_eigenvalues()`

- `ase.calculators.vasp.Vasp` now supports the `efermi` and `nelmgw`.

- The `ase.calculators.orca.ORCA` calculator has been refactored to be based on `ase.calculators.GenericFileIOCalculator`.

- The `ase.calculators.abinit.AbinitProfile` now correctly executes in the user-specified directory.

- Fix reading of eigenvalues in `ase.calculators.dftb` (MR: !2819)

- Added an `energies` property to the `lammpslib` calculator (MR: !2799)

- `ase.calculator.lammpslib.is_upper_triangular()` is deprecated. Use the method outlined in this StackOverflow post (MR: !3102)

- `ase.calculator.lammpslib.convert_cell()` is deprecated. Please use `ase.calculators.lammps.coordinatetransform.calc_rotated_cell()` instead. (MR: !3102)

- Fix `lsubsrot` typo in VASP calculator to `lsubrot` (MR: !2762)

- Fix atomic polarizability for boron in `ase.calculators.bond_polarizability.LippincottStuttman` (MR: !2759)

- `dielectric_tensor` and `born_effective_charges` parsing have been added to the aims and VASP calculators (MR: !2750)

- Update MOPAC calculator to support v22 (MR: !2745)

- Fix ordering of forces in `lammpsrun` calculator when used with MPI (MR: !2737)

- FLEUR calculator has been removed in favor of external package (MR: !2736)

- Compatability fixes for newer versions of Octopus (MR: !2734)

- Fixed conversion of force units between LAMMPS and ASE (MR: !2720)

- ORCA calculator now returns the correct energy in internal geometry optimizations (MR: !2699)

- Support for 24Mar2022 version of LAMMPS in `lammpsrun` calculator (MR: !2693)

- DFTB+ calculator now supports the use of an xTB Hamiltonian (MR: !2682)

- Fix WIEN2K writer when `rmt` is not `None` (MR: !2677)

- CP2K calculator support for libcx inputs (MR: !2676)

- Fix bug in `ase run --equation-of-state` (MR: !2675)

- Support PBCs in Plumed calculator (MR: !2671)

- Support z-matrix format for `FixCartesian` constraints in Siesta (MR: !2669)

- Support spin-orbit coupling and non-colinear calculations in Siesta (MR: !2665, MR: !2665)

- Support `k_grid_density` keyword in FHI-AIMS calculator (MR: !2662)

- Fix storing of `special_params` in VASP calculator (MR: !2661)

- Fix VASP OUTCAR parsing for systems with over 10 unique elements (MR: !2658)

- Cache all available properties in the mixing calculators (MR: !2646)

- Refactoring and bug fixes for `ase.calculators.dftd3.DFTD3` (MR: !2615)

- Added `ase.calculators.vasp.Vasp.read_vib_modes()` and `ase.calculators.vasp.Vasp.get_vibrations()` to read VASP-calculated vibrational modes (MR: !2605)

- `ase.calculators.nwchem.NWChem` now supports making initial guesses for wavefunctions using smaller basis sets and faster theories

- `ase.calculators.nwchem.NWChem` added support for direct and RI-MP2 computations.

Algorithms:

- Fix bugs in `PrimitiveNeighborList` when used with `bothways=True` and either `self_interaction=True` or `sorted=True` (MR: !3239)

- Change `ase.optimize.optimize.Dynamics.irun()` so that it yields its convergence status after logging and dumping for the corresponding step (issue: #1339; MR: !3072)

- `ExpCellFilter` is deprecated. Use `FrechetCellFilter` instead. (MR: !2981)

- Fix inconsistency of `mask` in `FixCartesian` between the argument and the attribute. (MR: !3195)

Optimizers:

- Add `ase.optimize.climbfixinternals.BFGSClimbFixInternals` class for transition state search and optimization along internal reaction coordinates (MR: !2299)

- `ase.optimize.optimize.Optimizers.irun()` and `ase.optimize.optimize.Optimizers.run()` now respect `steps=0` (issue: #1183; issue: #1258; MR: !2922).

- Added the `.trajectory` attribute to `ase.optimize.optimize.Dynamics` (MR: !2901).

- Fixed a bug when `ase.optimize.precon.precon.PreconImages` is initialized with a list of `precon` objects (MR: !2875)

- `ase.optimize.mdmin.MDMin` now takes in a `maxstep` parameter that directly restricts how much atoms can move in a single optimization step (MR: !3065).

- Removed `Berny` optimizer (MR: !3151)

Thermochemistry:

- All thermochemistry modules now sort the vibrational energies before cutting them down to the physically appropriate amount.

I/O:

- Add support for reading Mulliken, Löwdin, or Hirshfeld atomic charges in `ase.io.gaussian.read_gaussian_out()` (MR: !3332)

- Add support for reading POSCAR files with negative and multiple scaling factors in `ase.io.vasp.read_vasp()` (MR: !3029)

- Fix parsing of dipole moment in `ase.io.nwchem` from output files with trailing spaces (MR: !3018)

- Fix to read and write a compressed trajectory file like `xxx.traj.gz` (MR: !2997)

- Fix `index` of `ase.io.vasp.read_vasp_xdatcar()` to be consistent with `ase.io.read()` (MR: !2993)

- Change `write_lammps_data` not to reshape the cell by default (MR: !2986)

- Fix `ase.io.lammpsdata.write_lammps_data()` to tilt the cell correctly (MR: !2986)

- GaussView-formatted `.mol` files can now be read (MR: !2956)

- Reading of “chemical json” file types is assigned to names `*.cjson` as used in avogadro2

- Fixes `IndexError` when `lammps_data_to_ase_atoms()` is run on a system with 1 atom.

- Added several missing `__init__` parameters to `self` in `ase.io.trajectory.TrajectoryReader` and `ase.io.trajectory.TrajectoryWriter`.

- Add an option to `ase.io.lammpsdata.write_lamps_data()` to print the atomic masses.

- Add support for reading CUBE files with “negative” number of atoms, as is common in Gaussian.

- Fix parsing of periodic boundary conditions for `extxyz` format.

- Increase compatibility of CIF parser

- Extended XYZ writer now works with `GenericFileIOCalculator`

- Add numerical stress skips for SCF re-initialization in `ase.io.aims.AimsOutCalcChunk`.

- Deprecated calling `ase.io.aims.write_aims()` with `velocities`. Use `write_velocities` instead (MR: !2910).

- Fix `ValueError` that was raised when using quaternions with `ase.io.lammpsrun.lammps_data_to_ase_atoms()`.

- `ase.io.castep.CASTEP` now suports reading `.castep` force blocks

- `ase.io.castep.CASTEP` no longer reads symmetry operations.

- Added `ase.io.abinit.read_abinit_gsr()` to read a netcdf file (MR: !2855)

- SDF reader can now read file with >100 atoms (MR: !2845)

- `ase.io.v_sim.read_v_sim()` now properly accounts for periodic boundary conditions (MR: !2835)

- Bug fix in the `ase.io.aims` parser for reading the eigenvalues (MR: !2825)

- Recognize `.castep` files from Materials Studio (MR: !2822)

- Enable reading of GPAW stresses from gpaw-out file (MR: !2798)

- Add support for reading a VASP VTST CENTCAR file (MR: !2751)

- Fix I/O for FHI-aims when the minimal basis set is used (MR: !2738)

- Fix XYZ read/write round-trip when initial and final charges are set (MR: !2692)

- CASTEP I/O can now read/write custom masses (MR: !2686)

- Default dmol3 extension for arc files is now .arc (MR: !2686)

- Add PBC support for `ase.io.cube` (MR: !2679)

- Fix `sort_by_id=True` setting in `ase.io.lammpsdata.read_lammps_data()` (MR: !2660)

- More robust GPAW log file reading (MR: !2609)

- Fix for PDB file I/O involving trajectories (MR: !2598)

- Improved XCrysden file I/O (MR: !2594)

- Fix JSON encoder for Atoms objects with `FixAtoms` constraints (MR: !2592)

- Removed `ase.io.gaussian_reader` (MR: !2329)

## Version 3.22.1

1 December 2021: 3.22.1

- Fixed compatibility of Brillouin zone plotting with matplotlib 3.5+.

## Version 3.22.0

24 June 2021: 3.22.0

Calculators:

- `ase.calculators.qmmm.ForceQMMM` was updated to enable correct handling of various periodic boundary conditions. Functions to import and export files with QM/MM mapping were also added.

- It is now possible to use `Abinit` together with `SocketIOCalculator`. Requires Abinit 9.4+.

- It is now possible to pass a function to `SocketIOCalculator` to customize startup of a socket client. This decouples socket I/O calculators from `FileIOCalculator`.

- Added `PySocketIOClient`, a helper class for using the socket I/O calculator with Python clients.

- OpenKIM calculator updated to support kimpy 2.0.0.

- DFTB+ calculator now reads dipole moments.

Algorithms:

- Dedicated class `ase.vibrations.VibrationsData` to improve the representation of vibrational modes and associated data.

- Major refactoring of `ase.vibrations.Vibrations`. The calculated vibrational data can now be exported as a `VibrationsData` object.

- `phonons.get_dos()` now returns a DOS object based on the new framework in `ase.spectrum`.

- `ase.vibrations.Vibrations` and `ase.phonons.Phonons` now use a simplified caching system where forces for each displacement are saved in JSON files inside a subdirectory. This breaks old cached calculations. Old vibrations calculations can be ported using a migration tool; see `python3 -m ase.vibrations.pickle2json --help`.

- Added `ase.md.contour_exploration.ContourExploration`. It evolves systems at fixed potential energy. This is useful for tracing potential energy contour lines or rapidly exploring the potential energy surface of a system and can be tuned to preferentially sample highly curved regions of the potential energy surface.

- `ase.neb.NEB` has been overhauled and given support for preconditioning via a new `precon` argument to its constructor, and two newly supported methods, `spline` for spline-interpolated tangets and `string` for the string method, both of which support preconditioning. The default behaviour should be unchanged.

- Interpolating NEB images on constrained atoms will now raise an error if the interpolated positions would become different depending on whether the constraints were applied. Pass `apply_constraint=True` or `False` to `ase.neb.NEB.interpolate()` or `ase.neb.interpolate()` to choose a specific behaviour and silence the error.

- 3D Brillouin zone plots are now guaranteed isometric with Matplotlib 3.3+.

I/O:

- Gaussian input file parsing has been greatly improved. The parser now extracts all variables from the input file.

- Reading of “chemical json” file types with name `*.cml` is enabled.

- LAMMPS dump: Reading of elements column added, with priority over types if given. All four of the position specifier columns read correctly now.

- Format readers that would by default read or write specific files into current working directory no longer do so. A path, whether absolute or relative, is now mandatory for all I/O functions.

- The Siesta .XV format is now a recognized I/O format, `siesta-xv`.

- Parsing an OUTCAR file will now produce an Atoms object with periodic boundary conditions.

Breaking changes:

- For security, ASE no longer uses pickle for any kind of file I/O. This is because a maliciously crafted pickle file can execute arbitrary code.

  Features that used pickle now either use JSON, no longer support saving, or require a manual port of older pickle files using a migration tool. If you have many old calculations and rely on your own old (trusted) pickle files which cannot be loaded now, consider writing and contributing a migration tool for those files.

  The old PickleTrajectory format can still be loaded by manually overriding the security check.

  Pickle is still used for communication between processes started by ASE (such as plotting tools in the GUI), which is not a security problem since an attacker cannot tamper with the data unless the system is already compromised.

GUI:

- Added Finnish translation.

Bug fixes:

- Fix deadlock with DFTD3 calculator in MPI calculations.

- Fix parsing of Quantum Espresso outputs with more than 1000 atoms.

- Write netcdf trajectories compatible with Amber 20.

- Fix bug where constraints could be applied inconsistently in MD simulations.

- Allow disabling thermostat and barostat in NPT molecular dynamics.

- Fix problem with whitespace in CIF parser.

- Fix a problem where constraints would be applied inconsistently in MD simulations. As the interactions between MD and constraints are not trivial, users should in general verify carefully that simulations behave physically correctly.

- Fix issue where occupancies in `atoms.info` would subtly change type when saved to JSON and reloaded.

Web-page:

- There used to be two versions of the ASE web-page which was quite confusing. The https://wiki.fysik.dtu.dk/ase/dev/ web-page has now been dropped. There is now only https://wiki.fysik.dtu.dk/ase/ and it documents the use of the in development version of ASE.

## Version 3.21.1

24 January 2021: 3.21.1

- Fix incorrect positions written to CIF files with mixed boundary conditions.

- Writing a CIF with only 1 or 2 lattice vectors will now raise an error since CIF cannot represent those systems.

- The name of the Vasp calculator is now `'vasp'` as intended.

- Fix attribute error in `write_jmol()`.

## Version 3.21.0

18 January 2021: 3.21.0

General changes:

- `center()` now centers around 0 along directions which do not have a cell vector. Previously this operation had no effect in those directions.

- Deprecated the following methods on `Atoms` as they can be replaced by `~ase.cell.Cell`: `atoms.get_cell_lengths_and_angles()`, `atoms.get_reciprocal_cell()`, `atoms.number_of_lattice_vectors`. Instead use `atoms.cell.cellpar()`, `atoms.cell.reciprocal()`, and `atoms.cell.rank`, respectively.

- Removed deprecated code on `Atoms` for handling angles in radians.

- `get_velocities()` will now return zeros rather than `None` when there are no velocities, consistently with other optionals such as momenta.

- For security reasons, pickle will no longer be used for persistent file storage in the future. Pickle has so far been replaced with JSON in `ase.io.bundletrajectory.BundleTrajectory` and `ase.dft.stm.STM`. All remaining use of pickle for persistent storage will be likewise replaced in next release. Users are advised as always not to open pickle-files from untrusted sources.

- `ase.utils.opencew()` to be replaced by `ase.utils.xwopen()` which is a contextmanager and ensures that the file is closed correctly.

- Clusters created by `ase.cluster` will no longer have cell vectors and will be centered around (0, 0, 0). Previously they had a “tight” cell and coordinates centered with zero vacuum.

- Refactored external viewers in `ase.visualize.view`. Viewers will now clean up their temporary files correctly on non-UNIX platforms.

- Band structure module moved to `ase.spectrum.band_structure`.

- New objects for working with DOS and collections of DOS in `ase.spectrum`. To begin with, this will mostly be relevant for format readers that want to retrieve such objects from calculations.

Command-line interface:

- Added `ase exec` sub-command for the ase command line interface.

Algorithms:

- Removed `ase.build.voids` (MR: !2078)

- Removed unused code in `ase.transport.tools` (MR: !2077)

- Removed `ase.visualize.primiplotter` and `ase.visualize.fieldplotter` (MR: !2060)

- Changed units for molecular dynamics modules. They now accept the temperature in Kelvin as a keyword-only argument `temperature_K` and Berendsen NPT accepts the pressure in eV/Å³ as a keyword-only argument `pressure_au`. The previous arguments are still available and still take temperature and pressure in whatever unit the module used to accept, but now issue a warning.

- Made Andersen thermostat available for molecular dynamics simulation.

- Refactored `ase.neb.NEB`.

- The linear interpolation (`ase.neb.interpolate()`) between images now supports cell-interpolation and the use of scaled positions.

- `SingleCalculatorNEB` is deprecated. Use `ase.neb.NEB(allow_shared_calculator=True)` instead.

- Extended constraint `ase.constraints.FixInternals` by possibility to fix linear combinations of bond lengths.

- `FixInternals` constraints now support constraining linear combinations of angles or dihedrals. It is also possible to slice atoms objects with `FixInternals` constraints on them.

- Added `ase.build.connected` which finds groups of connected atoms inside an `Atoms` object.

- Optimizers and molecular dynamics objects, which may open trajectories or logfiles, can now be used as context managers. Doing so ensures correct closing of the files that they open.

- Faster codepath for minimum-image convention (MIC) distance calculations with “well-behaved” unit cells. This improves the speed of neighbour lists and certain constraints.

- Cleanup and deprecations of certain methods on `Phonons`.

Calculators:

- Removed `ase.calculators.ase_qmmm_manyqm` (MR: !2092)

- The `ignore_bad_restart_file` argument supported by many calculators has been deprecated. The user should choose this kind of behaviour explicitly.

- Cleaned up and fixed multiple issues with `ELK` calculator.

- Make-shift cleanup and fixes for `Exciting` calculator.

- `ase.calculators.abinit.Abinit` updated to work with Abinit 9.

- Improved cleanup of old socket files under some types of failure with `ase.calculators.socketio.SocketIOCalculator`.

- `Vasp` now uses the newer implementation formerly known as `Vasp2`. `Vasp2` is deprecated.

- Added smooth cutoff option to `ase.calculators.lj.LennardJones`. This makes the forces continuous as atoms move past the cutoff radius.

- `LennardJones` is now much more efficient.

- Many calculators would change the working directory in order to facilitate work with files. However doing so breaks threading. This has been fixed for most calculators (abinit, lammpsrun, )

I/O:

- Removed `ase.io.iwm` (MR: !2064)

- Removed `ase.io.plt` (MR: !2057)

- Reads Wannier90 `.wout` files. See `ase.io.wannier90.read_wout()` and `ase.io.wannier90.read_wout_all()`.

- `ase.io.pov.write_pov()` no longer includes an option to run povray on top of the written output. Instead it returns a renderer which can be used like this:

      png_path = write_pov('myfile.pov').render()

- Refactored CIF reader and writer, adding more extensive testing and fixing multiple bugs.

- CIF writer now uses up-to-date variable definitions from the CIF standard instead of deprecated ones. Also, it no longer writes columns of dummy data that doesn’t depend on the atoms.

- Added `ase.io.cif.CIFBlock` for direct access to data inside a CIF, and `ase.io.cif.parse_cif()` to iterate over such blocks from a CIF.

- Fixed many cases of careless I/O handling where format readers or writers would open files without necessarily closing them.

- Vasp output formats return atoms with fully periodic boundary conditions as appropriate.

- Vasp POSCAR/CONTCAR writer will now use the Vasp5 format by default.

Development:

- Test suite now prints a descriptive header with dependency versions including a list of installed/enabled calculators.

- All tests with random numbers now use a specific seed so as to run reproducibly.

- CI now supports integration testing with many additional calculators. The full list of external calculators that can be integration-tested via CI is: Abinit, Asap, CP2K, DFTB, DFTD3, Elk, Espresso, Exciting, GPAW, Gromacs, Lammpslib, Lammpsrun, NWChem, Octopus, OpenMX, Siesta.

## Version 3.20.1

11 August 2020: 3.20.1

> - Minor fix related to package version requirements on pypi.

## Version 3.19.3

11 August 2020: 3.19.3

> - Minor fix related to package version requirements on pypi.

> - Deprecated calling the `ase.optimize.fire.FIRE` constructor with `maxmove`; please use `maxstep` (MR: !1725).

## Version 3.20.0

8 August 2020: 3.20.0

General changes:

- Removed old `ase.data` modules (MR: !1720)

- `get_calculator()` and `set_calculator()` are deprecated. Use `atoms.calc` instead.

- `del atoms.calc` is deprecated. Use `atoms.calc = None` instead.

- The deprecated `atoms.cell.pbc` has been removed.

- More utility methods for `atoms.symbols`: `species()`, `search()`, `indices()`.

Development:

- Test suite now uses pytest. This means it requires pytest and optionally pytest-xdist for parallelization. The `ase test` command works as before although its output will be different and improved.

- Many tests have been improved and simplified, making use of pytest for parametrization and test fixtures.

- The continuous integration tests on Gitlab now use custom dockers. The docker files can be found at ase/ase-dockers.

- Some calculators can now be tested via Gitlab’s CI.

- Code coverage statistics are now available on https://ase.gitlab.io/ase. They currently exclude calculators and IO formats.

- Our CI now uses mypy for static analysis of the code.

Algorithms:

- Removed `ase.build.adsorb` (MR: !1845)

- Removed unused code in `ase.utils.ff` (MR: !1844)

- Removed `ase.utils.extrapolate` (MR: !1808)

- Functions for attaching structures in `attach` introduced.

- Standardize optimizers maximum step variable name to maxstep and default value to 0.2 for all optimizers.

- Added `Pyberny` geometry optimizer. This optimizer can be very efficient for molecules, but is currently unreliable and therefore should be considered experimental.

- Removed interface to FindSym due to lack of users and maintainers. If you need this, please find it in git history, make it work, and write tests. (MR: !1692)

- The tangent estimates used to make the nudged elastic band (NEB) plots are slightly improved to use center, rather than forward differences. This does not affect how NEBs are run; only how they are displayed.

- `ase.neb.NEBTools` now allows the simultaneous plotting of all bands from a trajectory of a nudged elastic band calculation (or similar); this funciton is also available at the command line as `ase nebplot neb.traj`.

- The image-dependent pair-potential (IDPP) interpolation scheme for connecting states—i.e., in a saddle-point search—has been moved into the method `ase.neb.idpp_interpolate()`. This method is a more feature-rich version than that accessible via `ase.neb.NEB.interpolate()`.

- Reduced code duplication in the `ase.ga` module by incorporating the ‘bulk’ GA functionality into the corresponding ‘standard’ modules. Using the now deprecated ‘bulk’ GA modules (i.e. `ase.ga.bulk_startgenerator`, `ase.ga.bulk_crossovers`, `ase.ga.bulk_mutations` and `ase.ga.bulk_utilities`) raises a warning with pointers to the corresponding ‘standard’ modules.

- Extended the genetic algorithm to cases where 1 or 2 cell vectors are part of the global optimization problem, which can be useful in searching for nanowire and thin film structures.

- Added a new tutorial on molecular crystal structure prediction using a genetic algorithm (Update: moved to ase-ga.)

- Allow setting the initial hessian in `optimize.BFGS` via the keyword `alpha` or explicitly via `opt.H0 = ...` after instantiation.

Command-line interface:

- New `dimensionality` sub-command for the ase command line interface.

- Added a diff CLI for displaying and comparing the positions, forces, and energies of atoms objects. The classes and functions used in the CLI are also available in `ase.cli.template`.

I/O:

- The `ase db db1.db <selection> --insert-into db2.db` command now respects `--limit` and `--offset`.

- Read and write support for qball sys file format.

- Added write support for the Vasp 5 XDATCAR file format.

- Added Z-matrix parser for use in input/output file readers.

- Added support for writing prismatic and computem xyz file. Required arguments to write mustem xtl file have been updated to be consistent with prismatic and computem xyz file export.

- Removed ETSF format reader since it depends on ScientificPython which requires Python 2.7.

- Removed Dacapo-NetCDF reader which has not worked since ancient times. (MR: !1892)

GUI:

- Use Ctrl+C, Ctrl+X, and Ctrl+V to copy/cut/paste atoms using the operating system’s clipboard. The copies use the JSON format.

- Removed old GUI modules which were never fully ported to Tkinter. If you miss them, please find them in git history and rehabilitate them.

> - Added Russian translation.

Calculators:

- Multiple improvements and bugfixes to OpenMX calculator; OpenMX calculator now supports OpenMX 3.9.

- Added `ORCA` calculator.

- Added `GAMESS-US` calculator.

- Removed interface to Dacapo due to lack of users and maintainers. (MR: !1721, MR: !1604)

- Completely refactored `Gaussian` calculator. The new calculator should be completely backwards compatible with the previous one, while having a more flexible design and supporting more keyword arguments.

- Added `GaussianOptimizer` and `GaussianIRC` classes for performing geometry optimization and IRC calculations with the Gaussian calculator. These classes are the canonical way to use Gaussian’s built-in geometry optimization routines.

- Fixed `kpts` option of `ase.calculators.espresso.Espresso` so that specifying a Γ-point calculation with `kpts=(1, 1, 1)` does not enable the optimized codepath (which halves memory and cpu). Use `kpts=None` to enable the optimized codepath.

- Added the properties `stresses` and `energies` to the Lennard-Jones potential `ase.calculators.lj.LennardJones`. Functionality for other properties should be unchanged. Testing and documentation have also been expanded.

## Version 3.19.2

22 July 2020: 3.19.2

- Compatibility fixes related to matplotlib: Update png writer to be compatible with matplotlib 3.3.0. Update incompatible calls to `matplotlib.use()`.

- Deprecated calling `ase.calculators.vasp.vasp2.Vasp2` constructor with directory in `label` parameter (MR: !1940)

## Version 3.19.1

4 April 2020: 3.19.1

- Update png writer to be compatible with matplotlib 3.2.

## Version 3.19.0

16 December 2019: 3.19.0

General changes:

- `ase.build.bulk()` now supports elements with tetragonal and rhombohedral lattices.

- The `rank` and `size` constants from the `ase.parallel` module have been deprecated. Use `world.rank` and `world.size` instead (and `from ase.parallel import world`).

- `atoms.set_masses('most_common')` now sets the masses of each element according to most common isotope as stored in `ase.data.atomic_masses_common`.

- `ase.utils.parsemath` added to utils. This module parses simple mathematical expressions and returns their numerical value.

- Plotting functions (such as band structure, EOS, …) no longer show the figure by default.

- `Atoms` constructor now accepts `velocities` as keyword.

- Documentation: New set of introductory ASE tutorials.

- More detailed output of `ase info --formats`.

- For completeness, `ase.lattice` now also supports the 1D Bravais lattice.

Algorithms:

- Added `DiffusionCoefficient` so one can calculate atom/molecule mobility from trajectory as a function of time.

- Added general linear parametric constraints `ase.constraints.FixParametricRelations`, `ase.constraints.FixScaledParametricRelations`, and `ase.constraints.FixCartesianParametricRelations` to `ase.constraints`. These constraints are based off the work in: arXiv: 1908.01610, and allows for the positions and cell of a structure to be optimized in a reduced parameter space.

- Added `ase.build.graphene()` for building graphene monolayers.

- Added `ase.md.switch_langevin` module for thermodynamic integration via MD simulations.

- Implemented “dynamic” or “ideal gas” contribution from atomic momenta to stress tensor Use `<ase.Atoms.get_stress>()`, e.g., `atoms.get_stress(include_ideal_gas=True)`.

Calculators:

- Added `Q-Chem` calculator.

- Added `Psi4` calculator.

- Added `DemonNano` calculator.

- Added `OpenKIM` calculator, a special calculator for OpenKim models.

- Gulp calculator now provides stress tensor.

- The `NWChem` calculator has been completely rewritten, and now supports DFT, SCF (Hartree Fock), MP2, CCSD, and TCE calculations with gaussian-type orbitals. The calculator also now supports plane-wave calculations, including band structure calculations through ASE’s `BandStructure` utilities. To facilitate these changes, the format of the calculator keywords has been changed. Please read the updated `NWChem` calculator documentation for more details.

- `Siesta` calculator refactored. The Siesta calculator now supports the band structure machinery. There is only a single Siesta calculator now covering all versions of Siesta, consistently with other ASE calculators.

- Added `mixing` module for the linear combination of arbitrary `calculators`.

- New `ase.calculators.idealgas.IdealGas` calculator for non-interacting atoms. The calculator does nothing. This can be useful for testing.

- `EMT` calculator now support atom-specific energies as per `atoms.get_energies()`.

I/O:

- Read and write support for RMCProfile (rmc6f) file format.

- Write support for Materials Studio xtd files.

- More efficient storage of the “data” part of rows in the `ase.db` database. NumPy arrays are now stored in binary format instead of as text thereby using approximately a factor of two less space when storing numbers of `np.float64`.

- The `pov` module can now render high-order bonds.

- `Atoms` now provides the general-purpose JSON mechanism from `ase.io.jsonio`.

- Added `ase.data.pubchem` module to search for structures in the PubChem database.

GUI:

- It is now possible to copy and paste atoms: The “add atoms” function (Ctrl+A) will suggest the atoms in the current selection by default.

## Version 3.18.2

15 December 2019: 3.18.2

- Fix an issue with the binary package (wheel) of 3.18.1. No bugfixes as such.

- Deprecated `ase.calculator.siesta.base_siesta`

## Version 3.18.1

20 September 2019: 3.18.1

- Multiple bugfixes. Most importantly, deprecate `atoms.cell.pbc` in order to avoid complexities from dealing with two ways of manipulating this piece of information. Use `atoms.pbc` instead; this works the same as always. Also, the `Cell` object now exposes almost the entire `ndarray` interface. For a list of smaller bugfixes, see the git log.

- Deprecated `ase.Atoms.get_number_of_atoms` (MR: !1295)

## Version 3.18.0

19 July 2019: 3.18.0

General changes:

- ASE no longer supports Python2.

- `atoms.cell` is now a `Cell` object. This object resembles a 3x3 array and also provides shortcuts to many common operations.

- Preliminary `Formula` type added. Collects all formula manipulation functionality in one place.

- `Symbols` objects, like `atoms.symbols`, now have a `formula` attribute.

- Added classes to represent primitive Bravais lattices and data relating to Brillouin zones to `ase.lattice`. Includes 2D lattices.

- New `BandPath` class to represent a band path specification like `'GXL'` along with actual k-point coordinates. `BandStructure` objects now have a band path.

- `ase.dft.kpoints.bandpath()` now returns a `BandPath` object. Generation of band paths now works for (almost) any cell.

- Use `atoms.cell.bandpath()` as a shortcut to generate band paths.

- New holonomic `constraint` for trilinear molecules.

- Added `ase info --calculators` option which shows a list of calculators and whether they appear to be installed.

- Added `ase.build.surfaces_with_termination.surfaces_with_termination()`, a tool to build surfaces with a particular termination.

- Use the shortcut `with ase.utils.workdir('mydir', mkdir=True): <code>` to temporarily change directories.

- The `ase test` command now properly autocompletes test names and calculator names.

- Added keyword, `atoms.wrap(pretty_translation=True)`, to minimize the scaled positions of the atoms.

Calculators:

- Added interface to `ACE-Molecule`.

- NWChem calculator now supports TDDFT runs.

- Multiple improvements to the ONETEP Calculator. Input files can now be written that specify LDOS, bsunfolding and many other functionalities.

- Calculation of stress tensor implemented for `EMT` potential.

- The `Octopus` calculator now provides the stress tensor.

- Reworked `LAMMPS` calculator. The calculator should now behave more consistently with other ASE calculators.

- Gromacs calculator updated to work with newer Gromacs.

- Fleur calculator updated to work with newer Fleur.

- Added `ACN`, a QM/MM forcefield for acetonitrile.

- Improved eigenvalue parsing with Siesta calculator.

Algorithms:

- Determine Bravais lattice for any 2D or 3D cell using `atoms.cell.get_bravais_lattice()`.

- Added function to Minkowski reduce a cell.

- Improved stability of Niggli reduction algorithm.

- Supercell generation using `ase.build.make_supercell()` now uses a constructive algorithm instead of cutting which was prone to tolerance errors.

- Setting an MD velocity distribution now preserves the temperature by default.

- `Analysis tool` for extracting bond lengths and angles from atoms.

- Dynamics and structure optimizers can now run as an iterator using the new `irun()` mechanism:

      for conv in opt.irun(fmax=0.05):
          print('hello')

  This makes it easier to execute custom code during runs. The `conv` variable indicates whether the current iteration meets the convergence criterion, although this behaviour may change in future versions.

- The genetic algorithm module `ase.ga` now has operators for crystal structure prediction. (Update: moved to ase-ga.)

- New `ase.geometry.dimensionality.analyze_dimensionality()` function. See: Dimensionality analysis.

- New `ase.utils.deltacodesdft.delta()` function: Calculates the difference between two DFT equation-of-states. See the new EOS: Calculating Delta-values tutorial.

- Holonomic `FixLinearTriatomic` for QM/MM calculations.

- The `NeighborList` now uses kdtree from Scipy for improved performance. It also uses Minkowsky reduction to improve performance for unusually shaped cells.

I/O:

- Database supports user defined tables

- Support for reading and writing DL_POLY format.

- Support for reading CP2K DCD format.

- Support for EON .con files with multiple images.

- Support for writing Materials Studio xtd format.

- Improved JSON support. Command line tool tools like ase band-structure and ase reciprocal now work with JSON representations of band structures and paths.

- Support reading CIF files through the Pycodcif library. This can be useful for CIF features that are not supported by the internal CIF parser.

- MySQL and MariaDB are supported as database backend

- Support for writing isosurface information to POV format with `ase.io.pov.add_isosurface_to_pov()`

GUI:

> - Quickinfo dialog automatically updates when switching image.

> - Display information about custom arrays on Atoms objects; allow colouring by custom arrays.

> - Improved color scales.

## Version 3.17.0

12 November 2018: 3.17.0

General changes:

- `atoms.symbols` is now an array-like object which works like a view of `atoms.numbers`, but based on chemical symbols. This enables convenient shortcuts such as `mask = atoms.symbols == 'Au'` or `atoms.symbols[4:8] = 'Mo'`.

- Test suite now runs in parallel.

- New `DOS` object for representing and plotting densities of states.

- Neighbor lists can now `get connectivity matrices`.

- ase convert now provides options to execute custom code on each processed image.

- `Phonons` class now uses the `DOS` and `BandStructure` machinery.

- Positions and velocities can now be initialized from phononic force constant matrix; see `PhononHarmonics()`.

Algorithms:

- New Gaussian Process (GP) regression optimizer (`GPMin`). Check out this performance test.

- New filter for lattice optimization, `ExpCellFilter`, based on an exponential reformulation of the degrees of freedom pertaining to the cell. This is probably significantly faster than `UnitCellFilter`.

- `UnitCellFilter` now supports scalar pressure and hydrostatic strain.

- Compare if two bulk structure are symmetrically equivalent with `SymmetryEquivalenceCheck`.

- `NEB` now supports a boolean keyword, `dynamic_relaxation`, which will freeze or unfreeze images according to the size of the spring forces so as to save force evaluations. Only implemented for serial NEB calculations.

- Writing a trajectory file from a parallelized `NEB` calculation is now much simpler. Works the same way as for the serial case.

- New `FixCom` constraint for fixing center of mass.

Calculators:

- Added `ase.calculators.qmmm.ForceQMMM` force-based QM/MM calculator.

- Socked-based interface to certain calculators through the `socketio` module: Added support for communicating coordinates, forces and other quantities over sockets using the i-PI protocol. This removes the overhead for starting and stopping calculators for each geometry step. The calculators which best support this feature are Espresso, Siesta, and Aims.

- Added calculator for `OpenMX`.

- Updated the `Castep` calculator as well as the related I/O methods in order to be more forgiving and less reliant on the presence of a CASTEP binary. The `castep_keywords.py` file has been replaced by a JSON file, and if its generation fails CASTEP files can still be read and written if higher tolerance levels are set for the functions that manipulate them.

- `Espresso` and `dftb` now support the `BandStructure` machinery including improved handling of kpoints, `get_eigenvalues()`, and friends.

I/O:

- CIF reader now parses fractional occupancies if present. The GUI visualizes fractional occupancies in the style of Pacman.

- Support for downloading calculations from the Nomad archive. Use `ase nomad-get nmd://<uri> ...` to download one or more URIs as JSON files. Use the `ase.nomad` module to download and work with Nomad entries programmatically. `nomad-json` is now a recognized IO format.

- Sequences of atoms objects can now be saved as animations using the mechanisms offered by matplotlib. `gif` and `mp4` are now recognized output formats.

Database:

- The `ase.db.core.Database.write()` method now takes a `id` that allows you to overwrite an existing row.

- The `ase.db.core.Database.update()` can now update the Atoms and the data parts of a row.

- The `ase.db.core.Database.update()` method will no longer accept a list of row ID’s as the first argument. Replace this:

      db.update(ids, ...)

  with:

      with db:
          for id in ids:
              db.update(id, ...)

- New `--show-keys` and `--show-values=...` options for the ase db command line interface.

- Optimized performance of ase db, with enhanced speed of queries on key value pairs for large SQLite (.db) database files. Also, The ase db server (PostgreSQL) backend now uses native ARRAY and JSONB data types for storing NumPy arrays and dictionaries instead of the BYTEA datatype. Note that backwards compatibility is lost for the postgreSQL backend, and that postgres version 9.4+ is required.

GUI:

- Added callback method `ase.gui.gui.GUI.repeat_poll()` to the GUI. Useful for programmatically updating the GUI.

- Improved error handling and communication with subprocesses (for plots) in GUI.

- Added Basque translation.

- Added French translation.

## Version 3.16.2

4 June 2018: 3.16.2

- Fix test failure for newer versions of flask due to error within the test itself. Fix trajectory format on bigendian architectures. Fix issue with trajectory files opened in append mode where header would not be written correctly for images with different length, atomic species, boundary conditions, or constraints.

## Version 3.16.0

21 March 2018: 3.16.0

- New linear-scaling neighbor list available as a function `neighbor_list()`.

- Castep calculator: option for automatic detection of pseudopotential files from a given directory (castep_pp_path); support for GBRV pseudopotential library; updated outfile parsing to comply with CASTEP 18.1.

- New LAMMPS calculator LAMMPSlib utilizing the Python bindings provided by LAMMPS instead of file I/O. Very basic calculator but can serve as base class for more sophisticated ones.

- Support for µSTEM xtl data format.

- New scanning tunnelling spectroscopy (STS) mode for `STM` simulations.

- New method, `get_angles()`, for calculating multiple angles.

- New `ase reciprocal` command for showing the 1. Brilluin zone, k-points and special points.

- New `ase convert` command for converting between file formats.

- Improved XRD/SAXS module: `ase.utils.xrdebye`.

- New cell editor for the GUI.

- Improved “quick info” dialog in the GUI. The dialog now lists results cached by the calculator.

- The “add atoms” dialog now offers a load file dialog as was the case before the tkinter port. It also provides a chooser for the G2 dataset.

- Interface for the `CRYSTAL <ase.calculators.crystal` code has been added.

- The `ase.dft.bandgap.bandgap()` function used with `direct=True` will now also consider spin-flip transitions. To get the spin-preserving direct gap (the old behavior), use:

      min(bandgap(..., spin=s, direct=True) for s in [0, 1])

- Bug fixed in the `ase.phonons.Phonons.symmetrize()` method when using an even number of repeats.

## Version 3.15.0

28 September 2017: 3.15.0

- If you are running your Python script in `parallel` then by default, `ase.io.read()` and `ase.io.iread()` will read on the master and broadcast to slaves, and `ase.io.write()` will only write from master. Use the new keyword `parallel=False` to read/write from the individual slaves.

- New `ase find` command for finding atoms in files.

- Added `Espresso` calculator for Quantum ESPRESSO in module `ase.calculators.espresso`.

- The `ase.dft.kpoints.get_special_points()` function has a new call signature: Before it was `get_special_points(lattice, cell)`, now it is `get_special_points(cell, lattice=None)`. The old way still works, but you will get a warning.

- The `ase.dft.dos.DOS` object will now use linear tetrahedron interpolation of the band-structure if you set `width=0.0`. It’s slow, but sometimes worth waiting for. It uses the `ase.dft.dos.linear_tetrahedron_integration()` helper function.

- `ase.io.read()` can now read QBox output files.

- The `ase.calculators.qmmm` module can now also use Turbomole and `DFTB+` as the QM part.

- New ASE Databases: Surface adsorption study tutorial.

- `ase.gui`: Improved atom colouring options; support the Render Scene (povray) and Ctrl+R rotation features again; updated German and Chinese translations.

- Get the `Spacegroup` object from an `Atoms` object with the new `ase.spacegroup.get_spacegroup()` function.

## Version 3.14.1

28 June 2017: 3.14.1.

- Calling the `ase.dft.bandgap.bandgap()` function with `direct=True` would return band indices that were off by one. Fixed now.

## Version 3.14.0

20 June 2017: 3.14.0.

- Python 2.6 no longer supported.

- The command-line tools ase-??? have been replaced by a single ase command with sub-commands (see Command line tool). For help, type:

      $ ase --help
      $ ase sub-command --help

- The old ase-build command which is now called ase build will no longer add vacuum by default. Use `ase build -V 3.0` to get the old behavior.

- All methods of the `Atoms` object that deal with angles now have new API’s that use degrees instead of radians as the unit of angle (`get_angle()`, `set_angle()`, `get_dihedral()`, `set_dihedral()`, `rotate_dihedral()`, `rotate()`, `euler_rotate()`).

  The old way of calling these methods works as always, but will give you a warning. Example:

      >>> water.get_angle(0, 1, 2)  # new API
      104.52
      >>> water.get_angle([0, 1, 2])  # old API
      /home/jensj/ase/ase/atoms.py:1484: UserWarning: Please use new API (which will return the angle in degrees): atoms_obj.get_angle(a1,a2,a3)*pi/180 instead of atoms_obj.get_angle([a1,a2,a3])
      1.8242181341844732

  Here are the changes you need to make in order to get rid of warnings:

  Old API:

      >>> a1 = atoms.get_angle([0, 1, 2])
      >>> atoms.set_angle([0, 1, 2], pi / 2)
      >>> a2 = atoms.get_dihedral([0, 1, 2, 3])
      >>> atoms.set_dihedral([0, 1, 2, 3], pi / 6)
      >>> atoms.rotate_dihedral([0, 1, 2, 3], 10.5 * pi / 180)
      >>> atoms.rotate('z', pi / 4)
      >>> atoms.rotate_euler(phi=phi, theta=theta, psi=psi)

  New API:

      >>> a1 = atoms.get_angle(0, 1, 2) * pi / 180
      >>> atoms.set_angle(0, 1, 2, angle=90)
      >>> a2 = atoms.get_dihedral(0, 1, 2, 3) * pi / 180
      >>> atoms.set_dihedral(0, 1, 2, 3, angle=30)
      >>> atoms.rotate_dihedral(0, 1, 2, 3, angle=10.5)
      >>> atoms.rotate(45, 'z')
      >>> atoms.euler_rotate(phi=phi * 180 / pi,
      ...                    theta=theta * 180 / pi,
      ...                    psi=psi * 180 / pi)

- The web-interface to the `ase.db` module now uses Bootstrap and looks much nicer. Querying the database is also much easier. See https://cmrdb.fysik.dtu.dk for an example.

- The PostgreSQL backend for `ase.db` can now contain more than one ASE database.

- An ASE database can now have Metadata describing the data. Metadata is a dict with any of the following keys: `title`, `key_descriptions`, `default_columns`, `special_keys` and `layout`.

- `ase.data.atomic_masses` has been updated to IUPAC values from 2016. Several elements will now have different weights which will affect dynamic calculations. The old values can be recovered like this:

      >>> from ase.data import atomic_masses_legacy
      >>> atoms.set_masses(atomic_masses_legacy[atoms.numbers])

- New `ase.data.isotopes.download_isotope_data()` function for getting individual isotope masses from NIST.

- New `ase.eos.calculate_eos()` helper function added.

- Added DeltaCodesDFT data: `ase.collections.dcdft`.

- `ase.gui` can now load and display any sequence of `Atoms` objects; it is no longer restricted to sequences with a constant number of atoms or same chemical composition.

- Trajectory files can now store any sequence of `Atoms` objects. Previously, atomic numbers, masses, and constraints were only saved for the first image, and had to apply for all subsequent ones.

- Added calculator interface for DMol3.

- Added calculator interface for GULP.

- Added file formats .car, .incoor, and .arc, related to DMol3.

- New function for interpolating from Monkhors-Pack sampled values in the BZ to arbitrary points in the BZ: `ase.dft.kpoints.monkhorst_pack_interpolate()`.

- New band-structure command for the ase Command line tool.

- Two new functions for producing chemical formulas: `ase.utils.formula_hill()` and `ase.utils.formula_metal()`.

- The `ase.dft.bandgap.get_band_gap()` function is now deprecated. Use the new one called `ase.dft.bandgap.bandgap()` (it’s more flexible and returns also band indices).

- New `Viewer for Jupyter notebooks`.

## Version 3.13.0

7 February 2017: 3.13.0.

- The default unit-cell when you create an `Atoms` object has been changed from `[[1,0,0],[0,1,0],[0,0,1]]` to `[[0,0,0],[0,0,0],[0,0,0]]`.

- New `ase.Atoms.number_of_lattice_vectors` attribute equal to, big surprise, the number of non-zero lattice vectors.

- The `ase.Atoms.get_cell()` method has a new keyword argument `complete`. Use `atoms.get_cell(complete=True)` to get a complete unit cell with missing lattice vectors added at right angles to the existing ones. There is also a function `ase.geometry.complete_cell()` that will complete a unit cell.

- `graphene_nanoribbon()` no longer adds 2.5 Å of vacuum by default.

- All functions that create molecules, chains or surfaces (see the `ase.build` module) will no longer add “dummy” lattice vectors along the non-periodic directions. As an example, the surface functions will generate unit cells of the type `[[a1,a2,0],[b1,b2,0],[0,0,0]]`. In order to define all three lattice vectors, use the `vacuum` keyword that all of the 0-d, 1-d and 2-d functions have or, equivalently, call the `center()` method.

- Many of the surface generating functions have changed their behavior when called with `vacuum=None` (the default). Before, a vacuum layer equal to the interlayer spacing would be added on the upper surface of the slab. Now, the third axis perpendicular to the surface will be undefined (`[0, 0, 0]`). Use `vacuum=<half-the-interlater-distance>` to get something similar to the old behavior.

- New `ase.geometry.is_orthorhombic()` and `ase.geometry.orthorhombic()` functions added.

- `ase.gui` now works on Python 3.

- NEB-tools class has been renamed to `NEBTools`.

- `Optimizers` now try force-consistent energies if possible (instead of energies extrapolated to 0.0 K).

## Version 3.12.0

24 October 2016: 3.12.0.

- New `ase.constraints.ExternalForce` constraint.

- Updated `ase.units` definition to CODATA 2014. Additionally, support for older versions of CODATA was added such that the respective units can be created by the user when needed (e.g. interfacing codes with different CODATA versions in use).

- New `ase.calculators.checkpoint` module. Adds restart and rollback capabilities to ASE scripts.

- Two new flawors of `NEB` calculations have been added: `method='eb'` and `method='improvedtangent'`.

- `ase.io.write()` can now write XSD files.

- Interfaces for deMon, Amber and ONETEP added.

- New Defect calculations: ASE Tools tutorial and new super-cell functions: `get_deviation_from_optimal_cell_shape()`, `find_optimal_cell_shape()`, `make_supercell()`.

- New `BandStructure` object. Can identify special points and create nice plots.

- Calculators that inherit from `ase.calculators.calculator.Calculator` will now have a `band_structure()` method that creates a `BandStructure` object.

- Addition to `geometry` module: `crystal_structure_from_cell()`.

- New functions in `ase.dft.kpoints` module: `parse_path_string()`, `labels_from_kpts()` and `bandpath()`.

- Helper function for generation of Monkhorst-Pack samplings and BZ-paths: `ase.calculators.calculator.kpts2ndarray()`.

- Useful class for testing band-structure stuff: `ase.calculators.test.FreeElectrons`.

- The `cell` attribute of an `Atoms` object and the `cell` keyword for the `Atoms` constructor and the `set_cell()` method now accepts unit cells given ase `[a, b, c, alpha, beta, gamma]`, where the three angles are in degrees. There is also a corresponding `get_cell_lengths_and_angles()` method.

- Galician translation of ASE’s GUI.

- Two new preconditioned structure optimizers available. See `ase.optimize.precon`.

- Trajectory files now contain information about the calculator and also information from an optimizer that wrote the trajectory.

## Version 3.11.0

10 May 2016: 3.11.0.

- Special \(\mathbf{k}\)-points from the [Setyawan-Curtarolo] paper was added: `ase.dft.kpoints.special_points`.

- New `ase.collections` module added. Currently contains the G2 database of molecules and the S22 set of weakly interacting dimers and complexes.

- Moved modules:

  - `ase.utils.eos` moved to `ase.eos`

  - `ase.calculators.neighborlist` moved to `ase.neighborlist`

  - `ase.lattice.spacegroup` moved to `ase.spacegroup`

- The `InfraRed` that used to be in the `ase.infrared` or `ase.vibrations.infrared` modules is now called `Infrared` and should be imported from the `ase.vibrations` module.

- Deprecated modules: `ase.structure`, `ase.utils.geometry`, `ase.utils.distance`, `ase.lattice.surface`. The functions from these modules that will create and manipulate `Atoms` objects are now in the new `ase.build` module. The remaining functions have been moved to the new `ase.geometry` module.

- The `ase.lattice.bulk()` function has been moved to `ase.build.bulk()`.

- Two new functions: `cell_to_cellpar()` and `cellpar_to_cell()`.

- We can now `read()` and `write()` magres files.

- `NEB` improvement: calculations for molecules can now be told to minimize ratation and translation along the path.

## Version 3.10.0

17 Mar 2016: 3.10.0.

- PickleTrajectory files can no longer be used. See Converting old PickleTrajectory files to new Trajectory files.

- New iterator function `ase.io.iread()` for iteratively reading Atoms objects from a file.

- The `ase.io.read()` function and command-line tools can now read `.gz` and `.bz2` compressed files.

- Two new decorators `parallel_function()` and `parallel_generator()` added.

- Source code moved to ase/ase.

- Preliminary `ase.calculators.qmmm` module.

- Improved `TIP3P` potential.

- Velocity Verlet will now work correctly with constraints.

- ASE’s GUI no longer needs a special GTK-backend for matplotlib to work. This will make installation of ASE much simpler.

- We can now `read()` and `write()` JSV files.

- New `ase.dft.kpoints.get_special_points()` function.

- New `ase.geometry.get_duplicate_atoms()` function for finding and removing atoms on top of each other.

- New: A replacement `Siesta` calculator was implemented. It closely follows the `ase.calculators.calculator.FileIOCalculator` class which should ease further development. Handling pseudopotentials, basis sets and ghost atoms have been made much more flexible in the new version.

## Version 3.9.1

21 July 2015: 3.9.1.

- Added function for finding maximally reduced Niggli unit cell: `ase.build.niggli_reduce()`.

- Octopus interface added (experimental).

## Version 3.9.0

28 May 2015: 3.9.0.

- Genetic algorithm implemented; `ase.ga`. This can be used for the optimization of: atomic cluster structure, materials properties by use of template structures. Extension to other projects related to atomic simulations should be straightforward.

- The `ase.lattice.bulk` function can now build the Wurtzite structure.

- The `ase.utils.timing.Timer` was moved from GPAW to ASE.

- New `ase.db` module.

- New functions: `ase.build.fcc211()` and `ase.visualize.mlab.plot()`.

- New `Atoms` methods: `ase.Atoms.get_distances()` and `ase.Atoms.get_all_distances()`.

- Bash completion can now be enabled.

- Preliminary support for Python 3.

- Wrapping: new `ase.Atoms.wrap()` method and `ase.geometry.wrap_positions()` function. Also added `wrap=True` keyword argument to `ase.Atoms.get_scaled_positions()` that can be used to turn off wrapping.

- New improved method for initializing NEB calculations: `ase.neb.NEB.interpolate()`.

- New pickle-free future-proof trajectory file format added: The TrajectoryReader and TrajectoryWriter objects.

- We can now do Phase diagrams and Pourbaix diagrams.

- New `ase.build.mx2()` function for 1T and 2H metal dichalcogenides and friends.

- New `ase.dft.bandgap.get_band_gap()` function

- `CP2K` interface.

## Version 3.8.0

22 October 2013: 3.8.0.

- ASE’s `gui` renamed from `ag` to `ase-gui`.

- New STM module.

- Python 2.6 is now a requirement.

- The old `ase.build.bulk` function is now deprecated. Use the new one instead (`ase.lattice.bulk()`).

- We’re now using BuildBot for continuous integration: https://ase-buildbot.fysik.dtu.dk/waterfall

- New interface to the JDFTx code.

## Version 3.7.0

13 May 2013: 3.7.0.

- ASE’s GUI can now be configured to be more friendly to visually impaired users: High contrast settings.

- The `ase.neb.NEB` object now accepts a list of spring constants.

- Important backwards incompatible change: The `ase.build.surface()` function now returns a right-handed unit cell.

- Mopac, NWChem and Gaussian interfaces and EAM potential added.

- New `set_initial_charges()` and `get_initial_charges()` methods. The `get_charges()` method will now ask the calculator to calculate the atomic charges.

- The Calculator interface proposal has been implemented and 6 ASE calculators are now based on the new base classes.

- ASE now runs on Windows and Mac.

- Global optimization: Constrained minima hopping added to ASE.

## Version 3.6.0

24 Feb 2012: 3.6.0.

- ASE GUI translations added, available: da_DK, en_GB, es_ES.

- New function for making surfaces with arbitrary Miller indices with the smallest possible surface unit cell: ase.build.surface()

- New ase.lattice.bulk() function. Will replace old ase.build.bulk() function. The new one will produce a more natural hcp lattice and it will use experimental data for crystal structure and lattice constants if not provided explicitly.

- New values for ase.data.covalent_radii from Cordeo et al..

- New command line tool: Command line tool and tests based on it: abinit, elk, fleur, nwchem.

- New crystal builder for ase-gui

- Van der Waals radii in ase.data

- ASE’s GUI (ase-gui) now supports velocities for both graphs and coloring

- Cleaned up some name-spaces:

  - `ase` now contains only `Atoms` and `Atom`

  - `ase.calculators` is now empty

## Version 3.5.1

24 May 2011: 3.5.1.

- Problem with parallel vibration calculations fixed.

## Version 3.5.0

13 April 2011: 3.5.0.

- Improved EMT potential: uses a `NeighborList` object and is now ASAP compatible.

- `ase.optimize.BFGSLineSearch>` is now the default (`QuasiNewton==BFGSLineSearch`).

- There is a new interface to the LAMMPS molecular dynamics code.

- New `ase.phonons` module.

- Van der Waals corrections for DFT, see GPAW usage.

- New `BundleTrajectory` added.

- Updated GUI:

  - Stability and usability improvements.

  - Povray render facility.

  - Updated expert user mode.

  - Enabled customization of colours and atomic radii.

  - Enabled user default settings via `~/.ase/gui.py`.

- `Database library` expanded to include:

  - The s22, s26 and s22x5 sets of van der Waals bonded dimers and complexes by the Hobza group.

  - The DBH24 set of gas-phase reaction barrier heights by the Truhlar group.

- Implementation of the Dimer method.

## Version 3.4.1

11 August 2010: 3.4.1.

- Changelog
  - Git master branch
  - Version 3.28.0
    - I/O
    - Calculators
    - Optimizers
    - Molecular dynamics
    - GUI
    - Documentation
    - Other changes
    - Bugfixes
  - Version 3.27.0
    - Thermochemistry
    - I/O
    - Calculators
    - Optimizers
    - Molecular dynamics
    - GUI
    - Documentation
    - Other changes
    - Bugfixes
  - Version 3.26.0
    - I/O
    - Calculators
    - Optimizers
    - Molecular dynamics
    - GUI
    - Development
    - Documentation
    - Other changes
    - Bugfixes
    - Structure tools
  - Version 3.25.0
    - I/O
    - Calculators
    - Optimizers
    - Molecular dynamics
    - GUI
    - Development
    - Other changes
  - Version 3.24.0
    - Requirements
    - Atoms
    - DB
    - Structure tools
    - Calculators / IO
    - GUI
    - Molecular Dynamics
    - Optimizers
    - Phonons
    - Pourbaix (MR: !3280)
    - Spectrum
    - Misc
    - Documentation
    - Testing
    - Units
    - Maintenance and dev-ops
  - Earlier releases